Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bugzilla DB migration completed. Please report issues to Infra team via email via infra@gentoo.org or IRC

Bug 606628

Summary: dev-libs/efl-1.17.0 with dev-libs/openssl-1.1.0c - lib/emile/emile_cipher_openssl.c:90:19: error: storage size of 'ctx' isn't known
Product: Gentoo Linux Reporter: eroen <gentoo>
Component: Current packagesAssignee: Joonas Niilola <juippis>
Status: RESOLVED WONTFIX    
Severity: normal CC: proxy-maint
Priority: Normal    
Version: unspecified   
Hardware: All   
OS: Linux   
URL: https://phab.enlightenment.org/D4616
Whiteboard:
Package list:
Runtime testing required: ---
Bug Depends on:    
Bug Blocks: 592438, 669514    
Attachments: dev-libs/efl-1.17.0:20170120-174040.log

Description eroen 2017-01-20 17:44:51 UTC
Created attachment 460758 [details]
dev-libs/efl-1.17.0:20170120-174040.log

libtool: compile:  x86_64-pc-linux-gnu-gcc -DHAVE_CONFIG_H -I. -I.. -I../src/lib/efl -I../src/static_libs/rg_etc -DPACKAGE_BIN_DIR=\"/usr/bin\" -DPACKAGE_LIB_DIR=\"/usr/lib64\" -DPACKAGE_DATA_DIR=\"/usr/share/emile\" -Wall -Wextra -Wpointer-arith -Wno-missing-field-initializers -fvisibility=hidden -fdata-sections -ffunction-sections -I../src/lib/emile -I../src/lib/emile -I../src/bindings/emile -I../src/bindings/emile -I../src/lib/eina -I../src/lib/eina -DEFL_EMILE_BUILD=1 -I../src/static_libs/lz4 -O0 -g -c lib/emile/emile_cipher_openssl.c  -fPIC -DPIC -o lib/emile/.libs/lib_emile_libemile_la-emile_cipher_openssl.o
lib/emile/emile_cipher_openssl.c: In function '_emile_cipher_init':
lib/emile/emile_cipher_openssl.c:52:4: warning: implicit declaration of function 'ERR_load_crypto_strings' [-Wimplicit-function-declaration]
    ERR_load_crypto_strings();
    ^~~~~~~~~~~~~~~~~~~~~~~
lib/emile/emile_cipher_openssl.c:53:4: warning: implicit declaration of function 'SSL_library_init' [-Wimplicit-function-declaration]
    SSL_library_init();
    ^~~~~~~~~~~~~~~~
lib/emile/emile_cipher_openssl.c:54:4: warning: implicit declaration of function 'SSL_load_error_strings' [-Wimplicit-function-declaration]
    SSL_load_error_strings();
    ^~~~~~~~~~~~~~~~~~~~~~
lib/emile/emile_cipher_openssl.c:55:4: warning: implicit declaration of function 'OpenSSL_add_all_algorithms' [-Wimplicit-function-declaration]
    OpenSSL_add_all_algorithms();
    ^~~~~~~~~~~~~~~~~~~~~~~~~~
lib/emile/emile_cipher_openssl.c: In function 'emile_binbuf_cipher':
lib/emile/emile_cipher_openssl.c:90:19: error: storage size of 'ctx' isn't known
    EVP_CIPHER_CTX ctx;
                   ^~~
lib/emile/emile_cipher_openssl.c:137:4: warning: implicit declaration of function 'EVP_CIPHER_CTX_init' [-Wimplicit-function-declaration]
    EVP_CIPHER_CTX_init(&ctx);
    ^~~~~~~~~~~~~~~~~~~
lib/emile/emile_cipher_openssl.c:159:4: warning: implicit declaration of function 'EVP_CIPHER_CTX_cleanup' [-Wimplicit-function-declaration]
    EVP_CIPHER_CTX_cleanup(&ctx);
    ^~~~~~~~~~~~~~~~~~~~~~
lib/emile/emile_cipher_openssl.c:90:19: warning: unused variable 'ctx' [-Wunused-variable]
    EVP_CIPHER_CTX ctx;
                   ^~~
lib/emile/emile_cipher_openssl.c: In function 'emile_binbuf_decipher':
lib/emile/emile_cipher_openssl.c:189:19: error: storage size of 'ctx' isn't known
    EVP_CIPHER_CTX ctx;
                   ^~~
lib/emile/emile_cipher_openssl.c:189:19: warning: unused variable 'ctx' [-Wunused-variable]
lib/emile/emile_cipher_openssl.c: In function 'emile_cipher_server_listen':
lib/emile/emile_cipher_openssl.c:298:35: warning: implicit declaration of function 'TLSv1_server_method' [-Wimplicit-function-declaration]
          r->ssl_ctx = SSL_CTX_new(TLSv1_server_method());
                                   ^~~~~~~~~~~~~~~~~~~
lib/emile/emile_cipher_openssl.c:298:35: warning: passing argument 1 of 'SSL_CTX_new' makes pointer from integer without a cast [-Wint-conversion]
In file included from lib/emile/emile_cipher_openssl.c:13:0:
/usr/include/openssl/ssl.h:1302:17: note: expected 'const SSL_METHOD * {aka const struct ssl_method_st *}' but argument is of type 'int'
 __owur SSL_CTX *SSL_CTX_new(const SSL_METHOD *meth);
                 ^~~~~~~~~~~
lib/emile/emile_cipher_openssl.c: In function 'emile_cipher_server_connect':
lib/emile/emile_cipher_openssl.c:743:35: warning: implicit declaration of function 'TLSv1_client_method' [-Wimplicit-function-declaration]
          r->ssl_ctx = SSL_CTX_new(TLSv1_client_method());
                                   ^~~~~~~~~~~~~~~~~~~
lib/emile/emile_cipher_openssl.c:743:35: warning: passing argument 1 of 'SSL_CTX_new' makes pointer from integer without a cast [-Wint-conversion]
In file included from lib/emile/emile_cipher_openssl.c:13:0:
/usr/include/openssl/ssl.h:1302:17: note: expected 'const SSL_METHOD * {aka const struct ssl_method_st *}' but argument is of type 'int'
 __owur SSL_CTX *SSL_CTX_new(const SSL_METHOD *meth);
                 ^~~~~~~~~~~
make[4]: *** [Makefile:26995: lib/emile/lib_emile_libemile_la-emile_cipher_openssl.lo] Error 1
make[3]: *** [Makefile:38429: all-recursive] Error 1
make[2]: *** [Makefile:13647: all] Error 2
make[1]: *** [Makefile:2587: all-recursive] Error 1
make: *** [Makefile:1723: all] Error 2
 * ERROR: dev-libs/efl-1.17.0::gentoo failed (compile phase):
 *   emake failed
Comment 1 eroen 2017-01-21 11:10:32 UTC
I have submitted a patch[0] upstream that fixes the build with openssl-1.1.0c. (I think I submitted it the right way at least) Unfortunately, there have been many changes to the related code between the EFL version currently in Gentoo (1.17.0 from a year ago) and the latest release (1.18.4), so backporting it would be a pain.

0: https://phab.enlightenment.org/D4616
Comment 2 Thomas Sachau gentoo-dev 2018-03-26 12:32:18 UTC
Since this is an upstream issue, there is not much we can do here at the moment. Upstream bug is also still open, so there is no patch for backporting.

If upstream fixes the bug, it will be in the next version, otherwise there is currently nothing we can do from Gentoo side, so closing this bug as resolved->upstream.
Comment 3 Thomas Sachau gentoo-dev 2018-03-26 12:47:48 UTC
reopening the bug, as it is a blocker for the openssl-1.1 tracker
Comment 4 Joonas Niilola gentoo-dev 2018-08-30 16:04:30 UTC
Efl-1.17.0 was removed from the tree and this issue has been fixed upstream in later versions of efl. Closing.